﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace PT
{
    public partial class PTC
    {
        private bool mouseHold = false;
        private bool mouseTiming = false;
        private bool ready = true;
        private bool dontSend = false;
        private double nativeX, nativeY;
        private int inverseX, inverseY;

        private void evaluateAxisBox(Point p) // which sends the FPT commands
        {
            pictureBox1.Location = p;
            label4.Text = "X: " + p.X;
            label5.Text = "Y: " + p.Y;

            // dividing the 180 degress into 127 and 126 sections for FPT mode
            double xRation = 0.705555;
            double yRation = 0.700000;

            nativeX = Math.Ceiling((double)p.X * xRation);
            nativeY = Math.Ceiling((double)p.Y * yRation);

            label6.Text = "Divided X: " + nativeX;
            label7.Text = "Divided Y: " + nativeY;

            inverseX = 127 - (int)nativeX;
            inverseY = 126 - (int)nativeY;

            p.X = inverseX;
            p.Y = inverseY;
            sendFPT(p);
        }
        private void panel1_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouseHold && mouseTiming)
            {
                Point p = e.Location;
                p.X -= 10;
                p.Y -= 10;

                // ensure it does not leave the panel
                if (p.X < 0)
                    p.X = 0;
                if (p.X > 180)
                    p.X = 180;
                if (p.Y < 0)
                    p.Y = 0;
                if (p.Y > 180)
                    p.Y = 180;

                evaluateAxisBox(p);
            }
        }
        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            mouseHold = true;
            initJoystick();
            enterFPT();
        }
        private void panel1_MouseUp(object sender, MouseEventArgs e)
        {
            mouseHold = false;
        }
    }
}