﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PT
{
    public partial class PTC
    {
        private Point[] sendSerialHistory = new Point[10];
        private int sendSerialHistoryCount = 0;

        private void initPoints()
        {
            for (int i = 0; i < 10; i++)
            {
                sendSerialHistory[i].X = 0;
                sendSerialHistory[i].Y = 0;
            }
        }
        private Point extractValuesFromString(string line)
        {
            Point p = new Point();
            string firstValue = "", secondValue = "";
            int i = 0, j = 0;
            bool goOn = false;
            while (i < line.Length)
            {
                if (line[i] == 'p' && !goOn)
                {
                    j = i + 1;
                    for (int c = 0; c < i; c++)
                    {
                        firstValue += line[c];
                    }
                    goOn = true;
                }
                else if (goOn)
                {
                    if (line[i] == 't')
                    {
                        for (int c = j; c < i; c++)
                        {
                            secondValue += line[c];
                        }
                    }
                }
                i++;
            }
            if (firstValue != "" && secondValue != "")
            {
                p.X = Convert.ToInt32(firstValue);
                p.Y = Convert.ToInt32(secondValue);
            }
            else
            {
                p.X = 0;
                p.Y = 0;
            }
            return p;
        }
        private int checkAmountBetween(int first, int second)
        {
            int amount;
            if (first < second)
            {
                amount = second - first;
            }
            else if (first > second)
            {
                amount = first - second;
            }
            else
            {
                amount = 0;
            }
            return amount;
        }
        private void checkSendSerialLine()
        {
            /*
            valid combinations
            *t*p
            **t*p
            ***t*p
            
            *t**p
            *t***p
            not done            
            */
            dontSend = false;
            sendSerialHistory[sendSerialHistoryCount] = extractValuesFromString(sendSerialLine);
            sendSerialHistoryCount++;
            if (sendSerialHistoryCount > 2)
                sendSerialHistoryCount = 0;

            // if the difference bettween the last 3 sends is more than 50 dont send
            // this will slow the user down
            for (int i = 0; i < 3 - 1; i++)
            {
                if (checkAmountBetween(sendSerialHistory[i].X, sendSerialHistory[i + 1].X) > 50)
                {
                    dontSend = true;
                }
                if (checkAmountBetween(sendSerialHistory[i].Y, sendSerialHistory[i + 1].Y) > 50)
                {
                    dontSend = true;
                }
            }
            //richTextBox1.AppendText(sendSerialHistory[sendSerialHistoryCount].X + " " + sendSerialHistory[sendSerialHistoryCount].Y + "\n");
        }
    }
}