﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using SlimDX.DirectInput; // a direct x wrapper for c# added to the references

namespace PT
{
    public partial class PTC
    {
        private bool joystickNotRunning = true;
        Joystick joystick;
        JoystickState ps3 = new JoystickState();
        DirectInput directInput = new DirectInput();
        int number = 0;

        private void initJoystick()
        {
            // beau: changed example from: http://stackoverflow.com/questions/16192750/joystick-c-sharp-analog-button
            // Search for Device
            var devices = directInput.GetDevices(DeviceClass.GameController, DeviceEnumerationFlags.AttachedOnly);
            if (devices.Count == 0) // || devices[number] == null)
            {
                // No Device
                return;
            }

            // Create Gamepad
            // beau: how could i add more than one joystick here? perhaps change [number]
            joystick = new Joystick(directInput, devices[number].InstanceGuid);
            // beau: game does not exist but this does not seem to effect it
            //joystick.SetCooperativeLevel(game.Window.Handle, CooperativeLevel.Exclusive | CooperativeLevel.Foreground);

            // Set Axis Range for the Analog Sticks between -1000 and 1000 
            foreach (DeviceObjectInstance deviceObject in joystick.GetObjects())
            {
                if ((deviceObject.ObjectType & ObjectDeviceType.Axis) != 0)
                    // beau: i should change this to 0 and 180 for my project
                    //joystick.GetObjectPropertiesById((int)deviceObject.ObjectType).SetRange(-1000, 1000);
                    joystick.GetObjectPropertiesById((int)deviceObject.ObjectType).SetRange(0, 180);
            }
            joystick.Acquire();

            // run in new thread
            runJoyStickDelegate js = new runJoyStickDelegate(runJoyStick);
            js.BeginInvoke(null, null);
        }
        delegate void runJoyStickDelegate();
        private void runJoyStick()
        {
            if (joystickNotRunning)
            {
                joystickNotRunning = false;
                Thread.Sleep(500); // give some time for serial port to warm up
                Point p = new Point();
                bool[] ps3buttons = new bool[20];
                while (!joystickNotRunning)
                {
                    if (!mouseHold)
                    {
                        mouseTiming = false;
                        ps3 = joystick.GetCurrentState();

                        p.X = ps3.X;
                        //p.Y = ps3.RotationZ; // uses the right joystick updown for tilt
                        p.Y = ps3.Y; // for actual joystick

                        label10.Text = "X: " + p.X;
                        label11.Text = "Y: " + p.Y;
                        evaluateAxisBox(p); // this may constantly send commands on a weak joystick neutral

                        ps3buttons = ps3.GetButtons(); // get the buttons for the button controller
                        if (ps3buttons[4] == true) //up
                        {
                            tiltAngle += Convert.ToInt32(numericUpDown1.Value);
                            evaluateButton();
                            Thread.Sleep(250);
                        }
                        if (ps3buttons[5] == true) //right
                        {
                            panAngle -= Convert.ToInt32(numericUpDown1.Value);
                            evaluateButton();
                            Thread.Sleep(250);
                        }
                        if (ps3buttons[6] == true)//down
                        {
                            tiltAngle -= Convert.ToInt32(numericUpDown1.Value);
                            evaluateButton();
                            Thread.Sleep(250);
                        }
                        if (ps3buttons[7] == true)//left
                        {
                            panAngle += Convert.ToInt32(numericUpDown1.Value);
                            evaluateButton();
                            Thread.Sleep(250);
                        }
                        if (ps3buttons[10] == true)//L1
                        {
                            decimal T = Convert.ToInt32(numericUpDown1.Value);
                            T--;
                            if (T < 1)
                                T = 1;
                            numericUpDown1.Value = T;
                            Thread.Sleep(125);
                        }
                        if (ps3buttons[11] == true)//R1
                        {
                            decimal T = Convert.ToInt32(numericUpDown1.Value);
                            T++;
                            if (T > 180)
                                T = 180;
                            numericUpDown1.Value = T;
                            Thread.Sleep(125);
                        }

                        mouseTiming = true;
                    }
                    else
                    {
                        Thread.Sleep(500);
                    }
                }
                joystickNotRunning = true;
            }
        }
    }
}