﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Net.Sockets; // for tcp
using System.Net; // for tcp

// try http://stackoverflow.com/questions/10200910/create-hello-wold-websocket-example

// decided to use the .net 4.5 websocket
// which did not work out well for i dont like the built in IIS server

// for "websockets" a handshake is required
/*
class Program
{
    static void Main(string[] args)
    {
        var listener = new TcpListener(IPAddress.Any, 8181);
        listener.Start();
        using (var client = listener.AcceptTcpClient())
        using (var stream = client.GetStream())
        using (var reader = new StreamReader(stream))
        using (var writer = new StreamWriter(stream))
        {
            writer.WriteLine("HTTP/1.1 101 Web Socket Protocol Handshake");
            writer.WriteLine("Upgrade: WebSocket");
            writer.WriteLine("Connection: Upgrade");
            writer.WriteLine("WebSocket-Origin: http://localhost:8080");
            writer.WriteLine("WebSocket-Location: ws://localhost:8181/websession");
            writer.WriteLine("");
        }
        listener.Stop();
    }
}
*/

// originally a tcp example from http://tech.pro/tutorial/704/csharp-tutorial-simple-threaded-tcp-server

namespace PT
{
    public partial class PTC
    {
        // globals for tcp
        private TcpListener tcpListener;
        private bool tcpListenerRunning;
        int port = 3000;

        private void initTCP()
        {
            tcpListenerRunning = true;
            this.tcpListener = new TcpListener(IPAddress.Any, port);

            //this.listenThread = new Thread(new ThreadStart(ListenForClients));
            //this.listenThread.Start();
            ListenForClientsDelegate lis = new ListenForClientsDelegate(ListenForClients);
            lis.BeginInvoke(null, null);
        }
        private void destructTCP()
        {
            tcpListenerRunning = false; // stays running in processes unless stopped
            // there is still a thread running from the listener somehow, check the parameterised thread perhaps replace with delegate
        }
        
        delegate void ListenForClientsDelegate();
        private void ListenForClients()
        {
            this.tcpListener.Start();
            while (tcpListenerRunning)
            {
                //blocks until a client has connected to the server
                TcpClient client = this.tcpListener.AcceptTcpClient();

                //create a thread to handle communication 
                //with connected client
                Thread clientThread = new Thread(new ParameterizedThreadStart(HandleClientComm));
                clientThread.Start(client);
            }
            this.tcpListener.Stop();
        }
        private void HandleClientComm(object client)
        {
            TcpClient tcpClient = (TcpClient)client;
            NetworkStream clientStream = tcpClient.GetStream();
            ASCIIEncoding encoder = new ASCIIEncoding();

            // websocket handshake
            bool sendHandshake = true;
            string handshake =
                "HTTP/1.1 101 Web Socket Protocol Handshake\r\n" +
                "Upgrade: WebSocket\r\n" +
                "Connection: Upgrade\r\n" +
                "WebSocket-Origin: http://www.websocket.org\r\n" +
                "WebSocket-Location: ws://echo.kabuzol.net:8181/\r\n";
            byte[] buffer = encoder.GetBytes(handshake);
            // the key sent from the client must be regenerated somehow for the handshake to work. the above wont work right

            byte[] message = new byte[4096];
            int bytesRead;
            while (true) // while there are bytes to be read
            {
                bytesRead = 0;
                try
                {
                    //blocks until a client sends a message
                    bytesRead = clientStream.Read(message, 0, 4096);
                }
                catch(Exception e)
                {
                    //a socket error has occured
                    richTextBox2.AppendText(e.ToString());
                    break;
                }
                if (bytesRead == 0)
                {
                    // the client has disconnected from the server
                    break;
                }
                else if(sendHandshake)
                {
                    try
                    {
                        //this sends a message back on this client stream
                        clientStream.Write(buffer, 0, buffer.Length);
                        clientStream.Flush();
                    }
                    catch(Exception e)
                    {
                        richTextBox2.AppendText(e.ToString());
                        break;
                    }
                    sendHandshake = false; // run once
                }

                //message has successfully been received
                richTextBox2.AppendText(encoder.GetString(message, 0, bytesRead));
            }

            tcpClient.Close(); // why close when no bytes left? perhaps add a delay here to allow connection to stay open and wait for more bytes
            clientStream.Close();
            // all connections will be mixed and must identify from one another in the message
        }

        // the client function
        private void sendTCP()
        {
            // this may cause an error when mashing send, a new thread may fix that
            TcpClient client = new TcpClient();
            string address = textBox5.Text;            

            IPAddress[] ipAr = new IPAddress[50];
            ipAr = Dns.GetHostAddresses(address);
            textBox5.Text = ipAr[0].ToString(); // if domain was resolved, replace it in the text field with the first ip

            ASCIIEncoding encoder = new ASCIIEncoding();
            byte[] buffer = encoder.GetBytes(textBox6.Text);

            try
            {
                IPEndPoint serverEndPoint = new IPEndPoint(ipAr[0], port);
                client.Connect(serverEndPoint);
                NetworkStream clientStream = client.GetStream();

                clientStream.Write(buffer, 0, buffer.Length);
                clientStream.Flush();

                // must read here if expecting a reply from the server
            }
            catch (Exception e)
            {
                richTextBox2.AppendText(e.ToString());
            }
        }
    }
}